//# (C) 2003/2004 by Vezhnevets Vladimir and Stanislav Soldatov. This code is under GNU Generel Public License


// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PLUGCVS_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PLUGCVS_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef PLUGCVS_EXPORTS
#define PLUGCVS_API __declspec(dllexport)
#else
#define PLUGCVS_API __declspec(dllimport)
#endif

#include <string>
#include <vector>

///     
int WINAPI _export Configure(
  int ItemNumber
);

///      FAR 
int WINAPI _export GetMinFarVersion(void);

///        .
void WINAPI _export GetPluginInfo(
  struct PluginInfo *Info
);

///    ,   DLL-  . FAR   ,    .
void WINAPI _export SetStartupInfo(
  const struct PluginStartupInfo *Info
);

///  OpenPlugin      .
HANDLE WINAPI _export OpenPlugin(
  int OpenFrom,
  int Item
);

///      log,  
void ShowLogs(int in_iStatus, const char *in_pcLogFile, bool in_bNoAskIfOk);

///     
bool GetFileList(std::vector <std::string> &out_psFiles, bool &io_bCurDirOnly);

///  CVS          
///  
int RunCVS(const char **in_ppcArgs, const char *in_pcLogFile, bool in_bCheckTimeout);

///    
const char *CreateTempFileName();

///   modified  added 
bool GetChangedList(std::string in_sDir, std::vector<std::string> &out_psFiles,
                    bool in_bCurDirOnly);

///     
bool GetConflictsList(std::string in_sDir, std::vector<std::string> &out_psFiles,
                      bool in_bCurDirOnly);

///   -      
bool GetSpecialList(std::string in_sDir, std::vector<std::string> &out_psFiles,
                    std::string in_sFlags, bool in_bCurDirOnly, bool in_bIgnoreReturn);

///   
bool MarkFiles(std::vector<std::string> &in_psFiles);

/// Self-explanatory
bool PerformCommit(std::vector<std::string> &in_psFiles, bool in_bBuildList);

///    CVSFS  
HANDLE Browse(const char *path=0);
///   FS
//void InitCVSFS(void);

bool GetUpdateParam(std::vector <const char *> &out_ppcArgs);
